// -----------------------------------------------------------------------------
// This file was autogenerated by symforce from template:
//     function/FUNCTION.h.jinja
// Do NOT modify by hand.
// -----------------------------------------------------------------------------

#pragma once

#include <matrix/math.hpp>

namespace sym {

/**
 * This function was autogenerated from a symbolic function. Do not modify by hand.
 *
 * Symbolic function: compute_mag_z_innov_var_and_h
 *
 * Args:
 *     state: Matrix24_1
 *     P: Matrix23_23
 *     R: Scalar
 *     epsilon: Scalar
 *
 * Outputs:
 *     innov_var: Scalar
 *     H: Matrix23_1
 */
template <typename Scalar>
void ComputeMagZInnovVarAndH(const matrix::Matrix<Scalar, 24, 1>& state,
                             const matrix::Matrix<Scalar, 23, 23>& P, const Scalar R,
                             const Scalar epsilon, Scalar* const innov_var = nullptr,
                             matrix::Matrix<Scalar, 23, 1>* const H = nullptr) {
  // Total ops: 161

  // Unused inputs
  (void)epsilon;

  // Input arrays

  // Intermediate terms (15)
  const Scalar _tmp0 = 2 * state(16, 0);
  const Scalar _tmp1 = 2 * state(17, 0);
  const Scalar _tmp2 =
      (Scalar(1) / Scalar(2)) * _tmp0 * state(2, 0) - Scalar(1) / Scalar(2) * _tmp1 * state(1, 0);
  const Scalar _tmp3 = 2 * state(1, 0);
  const Scalar _tmp4 = (Scalar(1) / Scalar(2)) * _tmp1 * state(2, 0) +
                       (Scalar(1) / Scalar(2)) * _tmp3 * state(16, 0);
  const Scalar _tmp5 = 4 * state(18, 0);
  const Scalar _tmp6 = (Scalar(1) / Scalar(2)) * _tmp0 * state(0, 0) +
                       (Scalar(1) / Scalar(2)) * _tmp1 * state(3, 0) -
                       Scalar(1) / Scalar(2) * _tmp5 * state(2, 0);
  const Scalar _tmp7 = (Scalar(1) / Scalar(2)) * _tmp0 * state(3, 0) -
                       Scalar(1) / Scalar(2) * _tmp1 * state(0, 0) -
                       Scalar(1) / Scalar(2) * _tmp5 * state(1, 0);
  const Scalar _tmp8 =
      -_tmp2 * state(3, 0) + _tmp4 * state(0, 0) + _tmp6 * state(1, 0) - _tmp7 * state(2, 0);
  const Scalar _tmp9 =
      -_tmp2 * state(1, 0) + _tmp4 * state(2, 0) - _tmp6 * state(3, 0) + _tmp7 * state(0, 0);
  const Scalar _tmp10 =
      -_tmp2 * state(2, 0) - _tmp4 * state(1, 0) + _tmp6 * state(0, 0) + _tmp7 * state(3, 0);
  const Scalar _tmp11 =
      -2 * std::pow(state(1, 0), Scalar(2)) - 2 * std::pow(state(2, 0), Scalar(2)) + 1;
  const Scalar _tmp12 = 2 * state(2, 0);
  const Scalar _tmp13 = _tmp12 * state(3, 0) - _tmp3 * state(0, 0);
  const Scalar _tmp14 = _tmp12 * state(0, 0) + _tmp3 * state(3, 0);

  // Output terms (2)
  if (innov_var != nullptr) {
    Scalar& _innov_var = (*innov_var);

    _innov_var = P(0, 20) * _tmp9 + P(1, 20) * _tmp10 + P(15, 20) * _tmp14 + P(16, 20) * _tmp13 +
                 P(17, 20) * _tmp11 + P(2, 20) * _tmp8 + P(20, 20) + R +
                 _tmp10 * (P(0, 1) * _tmp9 + P(1, 1) * _tmp10 + P(15, 1) * _tmp14 +
                           P(16, 1) * _tmp13 + P(17, 1) * _tmp11 + P(2, 1) * _tmp8 + P(20, 1)) +
                 _tmp11 * (P(0, 17) * _tmp9 + P(1, 17) * _tmp10 + P(15, 17) * _tmp14 +
                           P(16, 17) * _tmp13 + P(17, 17) * _tmp11 + P(2, 17) * _tmp8 + P(20, 17)) +
                 _tmp13 * (P(0, 16) * _tmp9 + P(1, 16) * _tmp10 + P(15, 16) * _tmp14 +
                           P(16, 16) * _tmp13 + P(17, 16) * _tmp11 + P(2, 16) * _tmp8 + P(20, 16)) +
                 _tmp14 * (P(0, 15) * _tmp9 + P(1, 15) * _tmp10 + P(15, 15) * _tmp14 +
                           P(16, 15) * _tmp13 + P(17, 15) * _tmp11 + P(2, 15) * _tmp8 + P(20, 15)) +
                 _tmp8 * (P(0, 2) * _tmp9 + P(1, 2) * _tmp10 + P(15, 2) * _tmp14 +
                          P(16, 2) * _tmp13 + P(17, 2) * _tmp11 + P(2, 2) * _tmp8 + P(20, 2)) +
                 _tmp9 * (P(0, 0) * _tmp9 + P(1, 0) * _tmp10 + P(15, 0) * _tmp14 +
                          P(16, 0) * _tmp13 + P(17, 0) * _tmp11 + P(2, 0) * _tmp8 + P(20, 0));
  }

  if (H != nullptr) {
    matrix::Matrix<Scalar, 23, 1>& _h = (*H);

    _h.setZero();

    _h(0, 0) = _tmp9;
    _h(1, 0) = _tmp10;
    _h(2, 0) = _tmp8;
    _h(15, 0) = _tmp14;
    _h(16, 0) = _tmp13;
    _h(17, 0) = _tmp11;
    _h(20, 0) = 1;
  }
}  // NOLINT(readability/fn_size)

// NOLINTNEXTLINE(readability/fn_size)
}  // namespace sym
