// -----------------------------------------------------------------------------
// This file was autogenerated by symforce from template:
//     function/FUNCTION.h.jinja
// Do NOT modify by hand.
// -----------------------------------------------------------------------------

#pragma once

#include <matrix/math.hpp>

namespace sym {

/**
 * This function was autogenerated from a symbolic function. Do not modify by hand.
 *
 * Symbolic function: predict_covariance
 *
 * Args:
 *     state: Matrix24_1
 *     P: Matrix23_23
 *     accel: Matrix31
 *     accel_var: Matrix31
 *     gyro: Matrix31
 *     gyro_var: Scalar
 *     dt: Scalar
 *
 * Outputs:
 *     res: Matrix23_23
 */
template <typename Scalar>
matrix::Matrix<Scalar, 23, 23> PredictCovariance(const matrix::Matrix<Scalar, 24, 1>& state,
                                                const matrix::Matrix<Scalar, 23, 23>& P,
                                                const matrix::Matrix<Scalar, 3, 1>& accel,
                                                const matrix::Matrix<Scalar, 3, 1>& accel_var,
                                                const matrix::Matrix<Scalar, 3, 1>& gyro,
                                                const Scalar gyro_var, const Scalar dt) {
  // Total ops: 1754

  // Unused inputs
  (void)gyro;

  // Input arrays

  // Intermediate terms (147)
  const Scalar _tmp0 = 2 * state(1, 0);
  const Scalar _tmp1 = _tmp0 * state(3, 0);
  const Scalar _tmp2 = -_tmp1 * dt;
  const Scalar _tmp3 = 2 * state(0, 0);
  const Scalar _tmp4 = _tmp3 * state(2, 0);
  const Scalar _tmp5 = _tmp4 * dt;
  const Scalar _tmp6 = _tmp2 - _tmp5;
  const Scalar _tmp7 = std::pow(state(3, 0), Scalar(2));
  const Scalar _tmp8 = _tmp7 * dt;
  const Scalar _tmp9 = std::pow(state(0, 0), Scalar(2));
  const Scalar _tmp10 = -_tmp9 * dt;
  const Scalar _tmp11 = std::pow(state(2, 0), Scalar(2));
  const Scalar _tmp12 = _tmp11 * dt;
  const Scalar _tmp13 = std::pow(state(1, 0), Scalar(2));
  const Scalar _tmp14 = _tmp13 * dt;
  const Scalar _tmp15 = _tmp10 + _tmp12 - _tmp14 + _tmp8;
  const Scalar _tmp16 = _tmp13 + _tmp7;
  const Scalar _tmp17 = _tmp11 + _tmp9;
  const Scalar _tmp18 = _tmp16 + _tmp17;
  const Scalar _tmp19 = _tmp0 * state(2, 0);
  const Scalar _tmp20 = -_tmp19 * dt;
  const Scalar _tmp21 = _tmp3 * state(3, 0);
  const Scalar _tmp22 = _tmp21 * dt;
  const Scalar _tmp23 = _tmp20 + _tmp22;
  const Scalar _tmp24 =
      P(0, 11) * _tmp18 + P(10, 11) * _tmp23 + P(11, 11) * _tmp6 + P(9, 11) * _tmp15;
  const Scalar _tmp25 =
      P(0, 10) * _tmp18 + P(10, 10) * _tmp23 + P(11, 10) * _tmp6 + P(9, 10) * _tmp15;
  const Scalar _tmp26 = P(0, 0) * _tmp18 + P(10, 0) * _tmp23 + P(11, 0) * _tmp6 + P(9, 0) * _tmp15;
  const Scalar _tmp27 = P(0, 9) * _tmp18 + P(10, 9) * _tmp23 + P(11, 9) * _tmp6 + P(9, 9) * _tmp15;
  const Scalar _tmp28 = _tmp10 + _tmp14;
  const Scalar _tmp29 = -_tmp12 + _tmp28 + _tmp8;
  const Scalar _tmp30 = _tmp0 * state(0, 0);
  const Scalar _tmp31 = _tmp30 * dt;
  const Scalar _tmp32 = 2 * state(2, 0) * state(3, 0);
  const Scalar _tmp33 = -_tmp32 * dt;
  const Scalar _tmp34 = _tmp31 + _tmp33;
  const Scalar _tmp35 = P(0, 1) * _tmp18 + P(10, 1) * _tmp23 + P(11, 1) * _tmp6 + P(9, 1) * _tmp15;
  const Scalar _tmp36 = _tmp20 - _tmp22;
  const Scalar _tmp37 = _tmp23 * gyro_var;
  const Scalar _tmp38 = _tmp36 * gyro_var;
  const Scalar _tmp39 = _tmp6 * gyro_var;
  const Scalar _tmp40 =
      P(1, 10) * _tmp18 + P(10, 10) * _tmp29 + P(11, 10) * _tmp34 + P(9, 10) * _tmp36;
  const Scalar _tmp41 =
      P(1, 11) * _tmp18 + P(10, 11) * _tmp29 + P(11, 11) * _tmp34 + P(9, 11) * _tmp36;
  const Scalar _tmp42 = P(1, 9) * _tmp18 + P(10, 9) * _tmp29 + P(11, 9) * _tmp34 + P(9, 9) * _tmp36;
  const Scalar _tmp43 = P(1, 1) * _tmp18 + P(10, 1) * _tmp29 + P(11, 1) * _tmp34 + P(9, 1) * _tmp36;
  const Scalar _tmp44 = _tmp12 + _tmp28 - _tmp8;
  const Scalar _tmp45 = -_tmp31 + _tmp33;
  const Scalar _tmp46 = P(0, 2) * _tmp18 + P(10, 2) * _tmp23 + P(11, 2) * _tmp6 + P(9, 2) * _tmp15;
  const Scalar _tmp47 = _tmp2 + _tmp5;
  const Scalar _tmp48 = P(1, 2) * _tmp18 + P(10, 2) * _tmp29 + P(11, 2) * _tmp34 + P(9, 2) * _tmp36;
  const Scalar _tmp49 =
      P(10, 10) * _tmp45 + P(11, 10) * _tmp44 + P(2, 10) * _tmp18 + P(9, 10) * _tmp47;
  const Scalar _tmp50 =
      P(10, 11) * _tmp45 + P(11, 11) * _tmp44 + P(2, 11) * _tmp18 + P(9, 11) * _tmp47;
  const Scalar _tmp51 = P(10, 2) * _tmp45 + P(11, 2) * _tmp44 + P(2, 2) * _tmp18 + P(9, 2) * _tmp47;
  const Scalar _tmp52 = P(10, 9) * _tmp45 + P(11, 9) * _tmp44 + P(2, 9) * _tmp18 + P(9, 9) * _tmp47;
  const Scalar _tmp53 =
      P(0, 12) * _tmp18 + P(10, 12) * _tmp23 + P(11, 12) * _tmp6 + P(9, 12) * _tmp15;
  const Scalar _tmp54 = -2 * _tmp7;
  const Scalar _tmp55 = -2 * _tmp11;
  const Scalar _tmp56 = _tmp54 + _tmp55 + 1;
  const Scalar _tmp57 = _tmp56 * dt;
  const Scalar _tmp58 =
      P(0, 13) * _tmp18 + P(10, 13) * _tmp23 + P(11, 13) * _tmp6 + P(9, 13) * _tmp15;
  const Scalar _tmp59 = -_tmp21;
  const Scalar _tmp60 = _tmp19 + _tmp59;
  const Scalar _tmp61 = _tmp60 * dt;
  const Scalar _tmp62 =
      P(0, 14) * _tmp18 + P(10, 14) * _tmp23 + P(11, 14) * _tmp6 + P(9, 14) * _tmp15;
  const Scalar _tmp63 = _tmp1 + _tmp4;
  const Scalar _tmp64 = _tmp63 * dt;
  const Scalar _tmp65 = -_tmp4;
  const Scalar _tmp66 = _tmp1 + _tmp65;
  const Scalar _tmp67 = accel(0, 0) - state(13, 0);
  const Scalar _tmp68 = -_tmp13;
  const Scalar _tmp69 = _tmp68 + _tmp7;
  const Scalar _tmp70 = -_tmp11;
  const Scalar _tmp71 = _tmp70 + _tmp9;
  const Scalar _tmp72 = accel(2, 0) - state(15, 0);
  const Scalar _tmp73 = _tmp30 + _tmp32;
  const Scalar _tmp74 = accel(1, 0) - state(14, 0);
  const Scalar _tmp75 = dt * (_tmp66 * _tmp67 + _tmp72 * (_tmp69 + _tmp71) + _tmp73 * _tmp74);
  const Scalar _tmp76 = -_tmp19;
  const Scalar _tmp77 = -_tmp9;
  const Scalar _tmp78 = -_tmp32;
  const Scalar _tmp79 = dt * (_tmp67 * (_tmp59 + _tmp76) + _tmp72 * (_tmp30 + _tmp78) +
                              _tmp74 * (_tmp16 + _tmp70 + _tmp77));
  const Scalar _tmp80 = P(0, 3) * _tmp18 + P(10, 3) * _tmp23 + P(11, 3) * _tmp6 + P(9, 3) * _tmp15;
  const Scalar _tmp81 =
      P(1, 12) * _tmp18 + P(10, 12) * _tmp29 + P(11, 12) * _tmp34 + P(9, 12) * _tmp36;
  const Scalar _tmp82 =
      P(1, 13) * _tmp18 + P(10, 13) * _tmp29 + P(11, 13) * _tmp34 + P(9, 13) * _tmp36;
  const Scalar _tmp83 =
      P(1, 14) * _tmp18 + P(10, 14) * _tmp29 + P(11, 14) * _tmp34 + P(9, 14) * _tmp36;
  const Scalar _tmp84 = P(1, 3) * _tmp18 + P(10, 3) * _tmp29 + P(11, 3) * _tmp34 + P(9, 3) * _tmp36;
  const Scalar _tmp85 =
      P(10, 12) * _tmp45 + P(11, 12) * _tmp44 + P(2, 12) * _tmp18 + P(9, 12) * _tmp47;
  const Scalar _tmp86 = P(10, 1) * _tmp45 + P(11, 1) * _tmp44 + P(2, 1) * _tmp18 + P(9, 1) * _tmp47;
  const Scalar _tmp87 =
      P(10, 13) * _tmp45 + P(11, 13) * _tmp44 + P(2, 13) * _tmp18 + P(9, 13) * _tmp47;
  const Scalar _tmp88 =
      P(10, 14) * _tmp45 + P(11, 14) * _tmp44 + P(2, 14) * _tmp18 + P(9, 14) * _tmp47;
  const Scalar _tmp89 = P(10, 3) * _tmp45 + P(11, 3) * _tmp44 + P(2, 3) * _tmp18 + P(9, 3) * _tmp47;
  const Scalar _tmp90 = P(1, 12) * _tmp75 - P(12, 12) * _tmp57 - P(13, 12) * _tmp61 -
                        P(14, 12) * _tmp64 + P(2, 12) * _tmp79 + P(3, 12);
  const Scalar _tmp91 = P(1, 1) * _tmp75 - P(12, 1) * _tmp57 - P(13, 1) * _tmp61 -
                        P(14, 1) * _tmp64 + P(2, 1) * _tmp79 + P(3, 1);
  const Scalar _tmp92 = P(1, 2) * _tmp75 - P(12, 2) * _tmp57 - P(13, 2) * _tmp61 -
                        P(14, 2) * _tmp64 + P(2, 2) * _tmp79 + P(3, 2);
  const Scalar _tmp93 = P(1, 13) * _tmp75 - P(12, 13) * _tmp57 - P(13, 13) * _tmp61 -
                        P(14, 13) * _tmp64 + P(2, 13) * _tmp79 + P(3, 13);
  const Scalar _tmp94 = P(1, 14) * _tmp75 - P(12, 14) * _tmp57 - P(13, 14) * _tmp61 -
                        P(14, 14) * _tmp64 + P(2, 14) * _tmp79 + P(3, 14);
  const Scalar _tmp95 = std::pow(dt, Scalar(2));
  const Scalar _tmp96 = _tmp95 * accel_var(0, 0);
  const Scalar _tmp97 = _tmp95 * accel_var(1, 0);
  const Scalar _tmp98 = _tmp95 * accel_var(2, 0);
  const Scalar _tmp99 = P(1, 3) * _tmp75 - P(12, 3) * _tmp57 - P(13, 3) * _tmp61 -
                        P(14, 3) * _tmp64 + P(2, 3) * _tmp79 + P(3, 3);
  const Scalar _tmp100 = 1 - 2 * _tmp13;
  const Scalar _tmp101 = _tmp100 + _tmp54;
  const Scalar _tmp102 = _tmp101 * dt;
  const Scalar _tmp103 = -_tmp7;
  const Scalar _tmp104 = _tmp103 + _tmp13;
  const Scalar _tmp105 = dt * (_tmp60 * _tmp74 + _tmp63 * _tmp72 + _tmp67 * (_tmp104 + _tmp71));
  const Scalar _tmp106 = -_tmp30;
  const Scalar _tmp107 = _tmp106 + _tmp32;
  const Scalar _tmp108 = _tmp107 * dt;
  const Scalar _tmp109 = _tmp19 + _tmp21;
  const Scalar _tmp110 = _tmp109 * dt;
  const Scalar _tmp111 = -_tmp1;
  const Scalar _tmp112 = _tmp11 + _tmp77;
  const Scalar _tmp113 =
      _tmp67 * (_tmp111 + _tmp4) + _tmp72 * (_tmp104 + _tmp112) + _tmp74 * (_tmp106 + _tmp78);
  const Scalar _tmp114 = _tmp26 * dt;
  const Scalar _tmp115 = P(0, 4) * _tmp18 + P(10, 4) * _tmp23 + P(11, 4) * _tmp6 + P(9, 4) * _tmp15;
  const Scalar _tmp116 =
      P(1, 0) * _tmp18 + P(10, 0) * _tmp29 + P(11, 0) * _tmp34 + P(9, 0) * _tmp36;
  const Scalar _tmp117 = _tmp113 * dt;
  const Scalar _tmp118 =
      P(1, 4) * _tmp18 + P(10, 4) * _tmp29 + P(11, 4) * _tmp34 + P(9, 4) * _tmp36;
  const Scalar _tmp119 =
      P(10, 0) * _tmp45 + P(11, 0) * _tmp44 + P(2, 0) * _tmp18 + P(9, 0) * _tmp47;
  const Scalar _tmp120 =
      P(10, 4) * _tmp45 + P(11, 4) * _tmp44 + P(2, 4) * _tmp18 + P(9, 4) * _tmp47;
  const Scalar _tmp121 = _tmp56 * _tmp96;
  const Scalar _tmp122 = _tmp60 * _tmp97;
  const Scalar _tmp123 = P(1, 0) * _tmp75 - P(12, 0) * _tmp57 - P(13, 0) * _tmp61 -
                         P(14, 0) * _tmp64 + P(2, 0) * _tmp79 + P(3, 0);
  const Scalar _tmp124 = _tmp63 * _tmp98;
  const Scalar _tmp125 = P(1, 4) * _tmp75 - P(12, 4) * _tmp57 - P(13, 4) * _tmp61 -
                         P(14, 4) * _tmp64 + P(2, 4) * _tmp79 + P(3, 4);
  const Scalar _tmp126 = P(0, 0) * _tmp117 - P(12, 0) * _tmp110 - P(13, 0) * _tmp102 -
                         P(14, 0) * _tmp108 + P(2, 0) * _tmp105 + P(4, 0);
  const Scalar _tmp127 = P(0, 13) * _tmp117 - P(12, 13) * _tmp110 - P(13, 13) * _tmp102 -
                         P(14, 13) * _tmp108 + P(2, 13) * _tmp105 + P(4, 13);
  const Scalar _tmp128 = P(0, 14) * _tmp117 - P(12, 14) * _tmp110 - P(13, 14) * _tmp102 -
                         P(14, 14) * _tmp108 + P(2, 14) * _tmp105 + P(4, 14);
  const Scalar _tmp129 = P(0, 12) * _tmp117 - P(12, 12) * _tmp110 - P(13, 12) * _tmp102 -
                         P(14, 12) * _tmp108 + P(2, 12) * _tmp105 + P(4, 12);
  const Scalar _tmp130 = P(0, 4) * _tmp117 - P(12, 4) * _tmp110 - P(13, 4) * _tmp102 -
                         P(14, 4) * _tmp108 + P(2, 4) * _tmp105 + P(4, 4);
  const Scalar _tmp131 = _tmp100 + _tmp55;
  const Scalar _tmp132 = _tmp131 * dt;
  const Scalar _tmp133 =
      dt * (_tmp67 * (_tmp112 + _tmp69) + _tmp72 * (_tmp111 + _tmp65) + _tmp74 * (_tmp21 + _tmp76));
  const Scalar _tmp134 = _tmp73 * dt;
  const Scalar _tmp135 = _tmp66 * dt;
  const Scalar _tmp136 = _tmp107 * _tmp72 + _tmp109 * _tmp67 + _tmp74 * (_tmp103 + _tmp17 + _tmp68);
  const Scalar _tmp137 = P(0, 5) * _tmp18 + P(10, 5) * _tmp23 + P(11, 5) * _tmp6 + P(9, 5) * _tmp15;
  const Scalar _tmp138 = _tmp136 * dt;
  const Scalar _tmp139 =
      P(1, 5) * _tmp18 + P(10, 5) * _tmp29 + P(11, 5) * _tmp34 + P(9, 5) * _tmp36;
  const Scalar _tmp140 =
      P(10, 5) * _tmp45 + P(11, 5) * _tmp44 + P(2, 5) * _tmp18 + P(9, 5) * _tmp47;
  const Scalar _tmp141 = P(1, 5) * _tmp75 - P(12, 5) * _tmp57 - P(13, 5) * _tmp61 -
                         P(14, 5) * _tmp64 + P(2, 5) * _tmp79 + P(3, 5);
  const Scalar _tmp142 = P(0, 5) * _tmp117 - P(12, 5) * _tmp110 - P(13, 5) * _tmp102 -
                         P(14, 5) * _tmp108 + P(2, 5) * _tmp105 + P(4, 5);
  const Scalar _tmp143 = P(0, 14) * _tmp138 + P(1, 14) * _tmp133 - P(12, 14) * _tmp135 -
                         P(13, 14) * _tmp134 - P(14, 14) * _tmp132 + P(5, 14);
  const Scalar _tmp144 = P(0, 13) * _tmp138 + P(1, 13) * _tmp133 - P(12, 13) * _tmp135 -
                         P(13, 13) * _tmp134 - P(14, 13) * _tmp132 + P(5, 13);
  const Scalar _tmp145 = P(0, 12) * _tmp138 + P(1, 12) * _tmp133 - P(12, 12) * _tmp135 -
                         P(13, 12) * _tmp134 - P(14, 12) * _tmp132 + P(5, 12);
  const Scalar _tmp146 = P(0, 5) * _tmp138 + P(1, 5) * _tmp133 - P(12, 5) * _tmp135 -
                         P(13, 5) * _tmp134 - P(14, 5) * _tmp132 + P(5, 5);

  // Output terms (1)
  matrix::Matrix<Scalar, 23, 23> _res;

  _res(0, 0) = std::pow(_tmp15, Scalar(2)) * gyro_var + _tmp15 * _tmp27 + _tmp18 * _tmp26 +
               std::pow(_tmp23, Scalar(2)) * gyro_var + _tmp23 * _tmp25 + _tmp24 * _tmp6 +
               std::pow(_tmp6, Scalar(2)) * gyro_var;
  _res(1, 0) = 0;
  _res(2, 0) = 0;
  _res(3, 0) = 0;
  _res(4, 0) = 0;
  _res(5, 0) = 0;
  _res(6, 0) = 0;
  _res(7, 0) = 0;
  _res(8, 0) = 0;
  _res(9, 0) = 0;
  _res(10, 0) = 0;
  _res(11, 0) = 0;
  _res(12, 0) = 0;
  _res(13, 0) = 0;
  _res(14, 0) = 0;
  _res(15, 0) = 0;
  _res(16, 0) = 0;
  _res(17, 0) = 0;
  _res(18, 0) = 0;
  _res(19, 0) = 0;
  _res(20, 0) = 0;
  _res(21, 0) = 0;
  _res(22, 0) = 0;
  _res(0, 1) = _tmp15 * _tmp38 + _tmp18 * _tmp35 + _tmp24 * _tmp34 + _tmp25 * _tmp29 +
               _tmp27 * _tmp36 + _tmp29 * _tmp37 + _tmp34 * _tmp39;
  _res(1, 1) = _tmp18 * _tmp43 + std::pow(_tmp29, Scalar(2)) * gyro_var + _tmp29 * _tmp40 +
               std::pow(_tmp34, Scalar(2)) * gyro_var + _tmp34 * _tmp41 +
               std::pow(_tmp36, Scalar(2)) * gyro_var + _tmp36 * _tmp42;
  _res(2, 1) = 0;
  _res(3, 1) = 0;
  _res(4, 1) = 0;
  _res(5, 1) = 0;
  _res(6, 1) = 0;
  _res(7, 1) = 0;
  _res(8, 1) = 0;
  _res(9, 1) = 0;
  _res(10, 1) = 0;
  _res(11, 1) = 0;
  _res(12, 1) = 0;
  _res(13, 1) = 0;
  _res(14, 1) = 0;
  _res(15, 1) = 0;
  _res(16, 1) = 0;
  _res(17, 1) = 0;
  _res(18, 1) = 0;
  _res(19, 1) = 0;
  _res(20, 1) = 0;
  _res(21, 1) = 0;
  _res(22, 1) = 0;
  _res(0, 2) = _tmp15 * _tmp47 * gyro_var + _tmp18 * _tmp46 + _tmp24 * _tmp44 + _tmp25 * _tmp45 +
               _tmp27 * _tmp47 + _tmp37 * _tmp45 + _tmp39 * _tmp44;
  _res(1, 2) = _tmp18 * _tmp48 + _tmp29 * _tmp45 * gyro_var + _tmp34 * _tmp44 * gyro_var +
               _tmp38 * _tmp47 + _tmp40 * _tmp45 + _tmp41 * _tmp44 + _tmp42 * _tmp47;
  _res(2, 2) = _tmp18 * _tmp51 + std::pow(_tmp44, Scalar(2)) * gyro_var + _tmp44 * _tmp50 +
               std::pow(_tmp45, Scalar(2)) * gyro_var + _tmp45 * _tmp49 +
               std::pow(_tmp47, Scalar(2)) * gyro_var + _tmp47 * _tmp52;
  _res(3, 2) = 0;
  _res(4, 2) = 0;
  _res(5, 2) = 0;
  _res(6, 2) = 0;
  _res(7, 2) = 0;
  _res(8, 2) = 0;
  _res(9, 2) = 0;
  _res(10, 2) = 0;
  _res(11, 2) = 0;
  _res(12, 2) = 0;
  _res(13, 2) = 0;
  _res(14, 2) = 0;
  _res(15, 2) = 0;
  _res(16, 2) = 0;
  _res(17, 2) = 0;
  _res(18, 2) = 0;
  _res(19, 2) = 0;
  _res(20, 2) = 0;
  _res(21, 2) = 0;
  _res(22, 2) = 0;
  _res(0, 3) = _tmp35 * _tmp75 + _tmp46 * _tmp79 - _tmp53 * _tmp57 - _tmp58 * _tmp61 -
               _tmp62 * _tmp64 + _tmp80;
  _res(1, 3) = _tmp43 * _tmp75 + _tmp48 * _tmp79 - _tmp57 * _tmp81 - _tmp61 * _tmp82 -
               _tmp64 * _tmp83 + _tmp84;
  _res(2, 3) = _tmp51 * _tmp79 - _tmp57 * _tmp85 - _tmp61 * _tmp87 - _tmp64 * _tmp88 +
               _tmp75 * _tmp86 + _tmp89;
  _res(3, 3) = std::pow(_tmp56, Scalar(2)) * _tmp96 - _tmp57 * _tmp90 +
               std::pow(_tmp60, Scalar(2)) * _tmp97 - _tmp61 * _tmp93 +
               std::pow(_tmp63, Scalar(2)) * _tmp98 - _tmp64 * _tmp94 + _tmp75 * _tmp91 +
               _tmp79 * _tmp92 + _tmp99;
  _res(4, 3) = 0;
  _res(5, 3) = 0;
  _res(6, 3) = 0;
  _res(7, 3) = 0;
  _res(8, 3) = 0;
  _res(9, 3) = 0;
  _res(10, 3) = 0;
  _res(11, 3) = 0;
  _res(12, 3) = 0;
  _res(13, 3) = 0;
  _res(14, 3) = 0;
  _res(15, 3) = 0;
  _res(16, 3) = 0;
  _res(17, 3) = 0;
  _res(18, 3) = 0;
  _res(19, 3) = 0;
  _res(20, 3) = 0;
  _res(21, 3) = 0;
  _res(22, 3) = 0;
  _res(0, 4) = -_tmp102 * _tmp58 + _tmp105 * _tmp46 - _tmp108 * _tmp62 - _tmp110 * _tmp53 +
               _tmp113 * _tmp114 + _tmp115;
  _res(1, 4) = -_tmp102 * _tmp82 + _tmp105 * _tmp48 - _tmp108 * _tmp83 - _tmp110 * _tmp81 +
               _tmp116 * _tmp117 + _tmp118;
  _res(2, 4) = -_tmp102 * _tmp87 + _tmp105 * _tmp51 - _tmp108 * _tmp88 - _tmp110 * _tmp85 +
               _tmp117 * _tmp119 + _tmp120;
  _res(3, 4) = _tmp101 * _tmp122 - _tmp102 * _tmp93 + _tmp105 * _tmp92 + _tmp107 * _tmp124 -
               _tmp108 * _tmp94 + _tmp109 * _tmp121 - _tmp110 * _tmp90 + _tmp117 * _tmp123 +
               _tmp125;
  _res(4, 4) = std::pow(_tmp101, Scalar(2)) * _tmp97 - _tmp102 * _tmp127 +
               _tmp105 * (P(0, 2) * _tmp117 - P(12, 2) * _tmp110 - P(13, 2) * _tmp102 -
                          P(14, 2) * _tmp108 + P(2, 2) * _tmp105 + P(4, 2)) +
               std::pow(_tmp107, Scalar(2)) * _tmp98 - _tmp108 * _tmp128 +
               std::pow(_tmp109, Scalar(2)) * _tmp96 - _tmp110 * _tmp129 + _tmp117 * _tmp126 +
               _tmp130;
  _res(5, 4) = 0;
  _res(6, 4) = 0;
  _res(7, 4) = 0;
  _res(8, 4) = 0;
  _res(9, 4) = 0;
  _res(10, 4) = 0;
  _res(11, 4) = 0;
  _res(12, 4) = 0;
  _res(13, 4) = 0;
  _res(14, 4) = 0;
  _res(15, 4) = 0;
  _res(16, 4) = 0;
  _res(17, 4) = 0;
  _res(18, 4) = 0;
  _res(19, 4) = 0;
  _res(20, 4) = 0;
  _res(21, 4) = 0;
  _res(22, 4) = 0;
  _res(0, 5) = _tmp114 * _tmp136 - _tmp132 * _tmp62 + _tmp133 * _tmp35 - _tmp134 * _tmp58 -
               _tmp135 * _tmp53 + _tmp137;
  _res(1, 5) = _tmp116 * _tmp138 - _tmp132 * _tmp83 + _tmp133 * _tmp43 - _tmp134 * _tmp82 -
               _tmp135 * _tmp81 + _tmp139;
  _res(2, 5) = _tmp119 * _tmp138 - _tmp132 * _tmp88 + _tmp133 * _tmp86 - _tmp134 * _tmp87 -
               _tmp135 * _tmp85 + _tmp140;
  _res(3, 5) = _tmp121 * _tmp66 + _tmp122 * _tmp73 + _tmp123 * _tmp138 + _tmp124 * _tmp131 -
               _tmp132 * _tmp94 + _tmp133 * _tmp91 - _tmp134 * _tmp93 - _tmp135 * _tmp90 + _tmp141;
  _res(4, 5) = _tmp101 * _tmp73 * _tmp97 + _tmp107 * _tmp131 * _tmp98 + _tmp109 * _tmp66 * _tmp96 +
               _tmp126 * _tmp138 - _tmp127 * _tmp134 - _tmp128 * _tmp132 - _tmp129 * _tmp135 +
               _tmp133 * (P(0, 1) * _tmp117 - P(12, 1) * _tmp110 - P(13, 1) * _tmp102 -
                          P(14, 1) * _tmp108 + P(2, 1) * _tmp105 + P(4, 1)) +
               _tmp142;
  _res(5, 5) = std::pow(_tmp131, Scalar(2)) * _tmp98 - _tmp132 * _tmp143 +
               _tmp133 * (P(0, 1) * _tmp138 + P(1, 1) * _tmp133 - P(12, 1) * _tmp135 -
                          P(13, 1) * _tmp134 - P(14, 1) * _tmp132 + P(5, 1)) -
               _tmp134 * _tmp144 - _tmp135 * _tmp145 +
               _tmp138 * (P(0, 0) * _tmp138 + P(1, 0) * _tmp133 - P(12, 0) * _tmp135 -
                          P(13, 0) * _tmp134 - P(14, 0) * _tmp132 + P(5, 0)) +
               _tmp146 + std::pow(_tmp66, Scalar(2)) * _tmp96 +
               std::pow(_tmp73, Scalar(2)) * _tmp97;
  _res(6, 5) = 0;
  _res(7, 5) = 0;
  _res(8, 5) = 0;
  _res(9, 5) = 0;
  _res(10, 5) = 0;
  _res(11, 5) = 0;
  _res(12, 5) = 0;
  _res(13, 5) = 0;
  _res(14, 5) = 0;
  _res(15, 5) = 0;
  _res(16, 5) = 0;
  _res(17, 5) = 0;
  _res(18, 5) = 0;
  _res(19, 5) = 0;
  _res(20, 5) = 0;
  _res(21, 5) = 0;
  _res(22, 5) = 0;
  _res(0, 6) =
      P(0, 6) * _tmp18 + P(10, 6) * _tmp23 + P(11, 6) * _tmp6 + P(9, 6) * _tmp15 + _tmp80 * dt;
  _res(1, 6) =
      P(1, 6) * _tmp18 + P(10, 6) * _tmp29 + P(11, 6) * _tmp34 + P(9, 6) * _tmp36 + _tmp84 * dt;
  _res(2, 6) =
      P(10, 6) * _tmp45 + P(11, 6) * _tmp44 + P(2, 6) * _tmp18 + P(9, 6) * _tmp47 + _tmp89 * dt;
  _res(3, 6) = P(1, 6) * _tmp75 - P(12, 6) * _tmp57 - P(13, 6) * _tmp61 - P(14, 6) * _tmp64 +
               P(2, 6) * _tmp79 + P(3, 6) + _tmp99 * dt;
  _res(4, 6) = P(0, 6) * _tmp117 - P(12, 6) * _tmp110 - P(13, 6) * _tmp102 - P(14, 6) * _tmp108 +
               P(2, 6) * _tmp105 + P(4, 6) +
               dt * (P(0, 3) * _tmp117 - P(12, 3) * _tmp110 - P(13, 3) * _tmp102 -
                     P(14, 3) * _tmp108 + P(2, 3) * _tmp105 + P(4, 3));
  _res(5, 6) = P(0, 6) * _tmp138 + P(1, 6) * _tmp133 - P(12, 6) * _tmp135 - P(13, 6) * _tmp134 -
               P(14, 6) * _tmp132 + P(5, 6) +
               dt * (P(0, 3) * _tmp138 + P(1, 3) * _tmp133 - P(12, 3) * _tmp135 -
                     P(13, 3) * _tmp134 - P(14, 3) * _tmp132 + P(5, 3));
  _res(6, 6) = P(3, 6) * dt + P(6, 6) + dt * (P(3, 3) * dt + P(6, 3));
  _res(7, 6) = 0;
  _res(8, 6) = 0;
  _res(9, 6) = 0;
  _res(10, 6) = 0;
  _res(11, 6) = 0;
  _res(12, 6) = 0;
  _res(13, 6) = 0;
  _res(14, 6) = 0;
  _res(15, 6) = 0;
  _res(16, 6) = 0;
  _res(17, 6) = 0;
  _res(18, 6) = 0;
  _res(19, 6) = 0;
  _res(20, 6) = 0;
  _res(21, 6) = 0;
  _res(22, 6) = 0;
  _res(0, 7) =
      P(0, 7) * _tmp18 + P(10, 7) * _tmp23 + P(11, 7) * _tmp6 + P(9, 7) * _tmp15 + _tmp115 * dt;
  _res(1, 7) =
      P(1, 7) * _tmp18 + P(10, 7) * _tmp29 + P(11, 7) * _tmp34 + P(9, 7) * _tmp36 + _tmp118 * dt;
  _res(2, 7) =
      P(10, 7) * _tmp45 + P(11, 7) * _tmp44 + P(2, 7) * _tmp18 + P(9, 7) * _tmp47 + _tmp120 * dt;
  _res(3, 7) = P(1, 7) * _tmp75 - P(12, 7) * _tmp57 - P(13, 7) * _tmp61 - P(14, 7) * _tmp64 +
               P(2, 7) * _tmp79 + P(3, 7) + _tmp125 * dt;
  _res(4, 7) = P(0, 7) * _tmp117 - P(12, 7) * _tmp110 - P(13, 7) * _tmp102 - P(14, 7) * _tmp108 +
               P(2, 7) * _tmp105 + P(4, 7) + _tmp130 * dt;
  _res(5, 7) = P(0, 7) * _tmp138 + P(1, 7) * _tmp133 - P(12, 7) * _tmp135 - P(13, 7) * _tmp134 -
               P(14, 7) * _tmp132 + P(5, 7) +
               dt * (P(0, 4) * _tmp138 + P(1, 4) * _tmp133 - P(12, 4) * _tmp135 -
                     P(13, 4) * _tmp134 - P(14, 4) * _tmp132 + P(5, 4));
  _res(6, 7) = P(3, 7) * dt + P(6, 7) + dt * (P(3, 4) * dt + P(6, 4));
  _res(7, 7) = P(4, 7) * dt + P(7, 7) + dt * (P(4, 4) * dt + P(7, 4));
  _res(8, 7) = 0;
  _res(9, 7) = 0;
  _res(10, 7) = 0;
  _res(11, 7) = 0;
  _res(12, 7) = 0;
  _res(13, 7) = 0;
  _res(14, 7) = 0;
  _res(15, 7) = 0;
  _res(16, 7) = 0;
  _res(17, 7) = 0;
  _res(18, 7) = 0;
  _res(19, 7) = 0;
  _res(20, 7) = 0;
  _res(21, 7) = 0;
  _res(22, 7) = 0;
  _res(0, 8) =
      P(0, 8) * _tmp18 + P(10, 8) * _tmp23 + P(11, 8) * _tmp6 + P(9, 8) * _tmp15 + _tmp137 * dt;
  _res(1, 8) =
      P(1, 8) * _tmp18 + P(10, 8) * _tmp29 + P(11, 8) * _tmp34 + P(9, 8) * _tmp36 + _tmp139 * dt;
  _res(2, 8) =
      P(10, 8) * _tmp45 + P(11, 8) * _tmp44 + P(2, 8) * _tmp18 + P(9, 8) * _tmp47 + _tmp140 * dt;
  _res(3, 8) = P(1, 8) * _tmp75 - P(12, 8) * _tmp57 - P(13, 8) * _tmp61 - P(14, 8) * _tmp64 +
               P(2, 8) * _tmp79 + P(3, 8) + _tmp141 * dt;
  _res(4, 8) = P(0, 8) * _tmp117 - P(12, 8) * _tmp110 - P(13, 8) * _tmp102 - P(14, 8) * _tmp108 +
               P(2, 8) * _tmp105 + P(4, 8) + _tmp142 * dt;
  _res(5, 8) = P(0, 8) * _tmp138 + P(1, 8) * _tmp133 - P(12, 8) * _tmp135 - P(13, 8) * _tmp134 -
               P(14, 8) * _tmp132 + P(5, 8) + _tmp146 * dt;
  _res(6, 8) = P(3, 8) * dt + P(6, 8) + dt * (P(3, 5) * dt + P(6, 5));
  _res(7, 8) = P(4, 8) * dt + P(7, 8) + dt * (P(4, 5) * dt + P(7, 5));
  _res(8, 8) = P(5, 8) * dt + P(8, 8) + dt * (P(5, 5) * dt + P(8, 5));
  _res(9, 8) = 0;
  _res(10, 8) = 0;
  _res(11, 8) = 0;
  _res(12, 8) = 0;
  _res(13, 8) = 0;
  _res(14, 8) = 0;
  _res(15, 8) = 0;
  _res(16, 8) = 0;
  _res(17, 8) = 0;
  _res(18, 8) = 0;
  _res(19, 8) = 0;
  _res(20, 8) = 0;
  _res(21, 8) = 0;
  _res(22, 8) = 0;
  _res(0, 9) = _tmp27;
  _res(1, 9) = _tmp42;
  _res(2, 9) = _tmp52;
  _res(3, 9) = P(1, 9) * _tmp75 - P(12, 9) * _tmp57 - P(13, 9) * _tmp61 - P(14, 9) * _tmp64 +
               P(2, 9) * _tmp79 + P(3, 9);
  _res(4, 9) = P(0, 9) * _tmp117 - P(12, 9) * _tmp110 - P(13, 9) * _tmp102 - P(14, 9) * _tmp108 +
               P(2, 9) * _tmp105 + P(4, 9);
  _res(5, 9) = P(0, 9) * _tmp138 + P(1, 9) * _tmp133 - P(12, 9) * _tmp135 - P(13, 9) * _tmp134 -
               P(14, 9) * _tmp132 + P(5, 9);
  _res(6, 9) = P(3, 9) * dt + P(6, 9);
  _res(7, 9) = P(4, 9) * dt + P(7, 9);
  _res(8, 9) = P(5, 9) * dt + P(8, 9);
  _res(9, 9) = P(9, 9);
  _res(10, 9) = 0;
  _res(11, 9) = 0;
  _res(12, 9) = 0;
  _res(13, 9) = 0;
  _res(14, 9) = 0;
  _res(15, 9) = 0;
  _res(16, 9) = 0;
  _res(17, 9) = 0;
  _res(18, 9) = 0;
  _res(19, 9) = 0;
  _res(20, 9) = 0;
  _res(21, 9) = 0;
  _res(22, 9) = 0;
  _res(0, 10) = _tmp25;
  _res(1, 10) = _tmp40;
  _res(2, 10) = _tmp49;
  _res(3, 10) = P(1, 10) * _tmp75 - P(12, 10) * _tmp57 - P(13, 10) * _tmp61 - P(14, 10) * _tmp64 +
                P(2, 10) * _tmp79 + P(3, 10);
  _res(4, 10) = P(0, 10) * _tmp117 - P(12, 10) * _tmp110 - P(13, 10) * _tmp102 -
                P(14, 10) * _tmp108 + P(2, 10) * _tmp105 + P(4, 10);
  _res(5, 10) = P(0, 10) * _tmp138 + P(1, 10) * _tmp133 - P(12, 10) * _tmp135 -
                P(13, 10) * _tmp134 - P(14, 10) * _tmp132 + P(5, 10);
  _res(6, 10) = P(3, 10) * dt + P(6, 10);
  _res(7, 10) = P(4, 10) * dt + P(7, 10);
  _res(8, 10) = P(5, 10) * dt + P(8, 10);
  _res(9, 10) = P(9, 10);
  _res(10, 10) = P(10, 10);
  _res(11, 10) = 0;
  _res(12, 10) = 0;
  _res(13, 10) = 0;
  _res(14, 10) = 0;
  _res(15, 10) = 0;
  _res(16, 10) = 0;
  _res(17, 10) = 0;
  _res(18, 10) = 0;
  _res(19, 10) = 0;
  _res(20, 10) = 0;
  _res(21, 10) = 0;
  _res(22, 10) = 0;
  _res(0, 11) = _tmp24;
  _res(1, 11) = _tmp41;
  _res(2, 11) = _tmp50;
  _res(3, 11) = P(1, 11) * _tmp75 - P(12, 11) * _tmp57 - P(13, 11) * _tmp61 - P(14, 11) * _tmp64 +
                P(2, 11) * _tmp79 + P(3, 11);
  _res(4, 11) = P(0, 11) * _tmp117 - P(12, 11) * _tmp110 - P(13, 11) * _tmp102 -
                P(14, 11) * _tmp108 + P(2, 11) * _tmp105 + P(4, 11);
  _res(5, 11) = P(0, 11) * _tmp138 + P(1, 11) * _tmp133 - P(12, 11) * _tmp135 -
                P(13, 11) * _tmp134 - P(14, 11) * _tmp132 + P(5, 11);
  _res(6, 11) = P(3, 11) * dt + P(6, 11);
  _res(7, 11) = P(4, 11) * dt + P(7, 11);
  _res(8, 11) = P(5, 11) * dt + P(8, 11);
  _res(9, 11) = P(9, 11);
  _res(10, 11) = P(10, 11);
  _res(11, 11) = P(11, 11);
  _res(12, 11) = 0;
  _res(13, 11) = 0;
  _res(14, 11) = 0;
  _res(15, 11) = 0;
  _res(16, 11) = 0;
  _res(17, 11) = 0;
  _res(18, 11) = 0;
  _res(19, 11) = 0;
  _res(20, 11) = 0;
  _res(21, 11) = 0;
  _res(22, 11) = 0;
  _res(0, 12) = _tmp53;
  _res(1, 12) = _tmp81;
  _res(2, 12) = _tmp85;
  _res(3, 12) = _tmp90;
  _res(4, 12) = _tmp129;
  _res(5, 12) = _tmp145;
  _res(6, 12) = P(3, 12) * dt + P(6, 12);
  _res(7, 12) = P(4, 12) * dt + P(7, 12);
  _res(8, 12) = P(5, 12) * dt + P(8, 12);
  _res(9, 12) = P(9, 12);
  _res(10, 12) = P(10, 12);
  _res(11, 12) = P(11, 12);
  _res(12, 12) = P(12, 12);
  _res(13, 12) = 0;
  _res(14, 12) = 0;
  _res(15, 12) = 0;
  _res(16, 12) = 0;
  _res(17, 12) = 0;
  _res(18, 12) = 0;
  _res(19, 12) = 0;
  _res(20, 12) = 0;
  _res(21, 12) = 0;
  _res(22, 12) = 0;
  _res(0, 13) = _tmp58;
  _res(1, 13) = _tmp82;
  _res(2, 13) = _tmp87;
  _res(3, 13) = _tmp93;
  _res(4, 13) = _tmp127;
  _res(5, 13) = _tmp144;
  _res(6, 13) = P(3, 13) * dt + P(6, 13);
  _res(7, 13) = P(4, 13) * dt + P(7, 13);
  _res(8, 13) = P(5, 13) * dt + P(8, 13);
  _res(9, 13) = P(9, 13);
  _res(10, 13) = P(10, 13);
  _res(11, 13) = P(11, 13);
  _res(12, 13) = P(12, 13);
  _res(13, 13) = P(13, 13);
  _res(14, 13) = 0;
  _res(15, 13) = 0;
  _res(16, 13) = 0;
  _res(17, 13) = 0;
  _res(18, 13) = 0;
  _res(19, 13) = 0;
  _res(20, 13) = 0;
  _res(21, 13) = 0;
  _res(22, 13) = 0;
  _res(0, 14) = _tmp62;
  _res(1, 14) = _tmp83;
  _res(2, 14) = _tmp88;
  _res(3, 14) = _tmp94;
  _res(4, 14) = _tmp128;
  _res(5, 14) = _tmp143;
  _res(6, 14) = P(3, 14) * dt + P(6, 14);
  _res(7, 14) = P(4, 14) * dt + P(7, 14);
  _res(8, 14) = P(5, 14) * dt + P(8, 14);
  _res(9, 14) = P(9, 14);
  _res(10, 14) = P(10, 14);
  _res(11, 14) = P(11, 14);
  _res(12, 14) = P(12, 14);
  _res(13, 14) = P(13, 14);
  _res(14, 14) = P(14, 14);
  _res(15, 14) = 0;
  _res(16, 14) = 0;
  _res(17, 14) = 0;
  _res(18, 14) = 0;
  _res(19, 14) = 0;
  _res(20, 14) = 0;
  _res(21, 14) = 0;
  _res(22, 14) = 0;
  _res(0, 15) = P(0, 15) * _tmp18 + P(10, 15) * _tmp23 + P(11, 15) * _tmp6 + P(9, 15) * _tmp15;
  _res(1, 15) = P(1, 15) * _tmp18 + P(10, 15) * _tmp29 + P(11, 15) * _tmp34 + P(9, 15) * _tmp36;
  _res(2, 15) = P(10, 15) * _tmp45 + P(11, 15) * _tmp44 + P(2, 15) * _tmp18 + P(9, 15) * _tmp47;
  _res(3, 15) = P(1, 15) * _tmp75 - P(12, 15) * _tmp57 - P(13, 15) * _tmp61 - P(14, 15) * _tmp64 +
                P(2, 15) * _tmp79 + P(3, 15);
  _res(4, 15) = P(0, 15) * _tmp117 - P(12, 15) * _tmp110 - P(13, 15) * _tmp102 -
                P(14, 15) * _tmp108 + P(2, 15) * _tmp105 + P(4, 15);
  _res(5, 15) = P(0, 15) * _tmp138 + P(1, 15) * _tmp133 - P(12, 15) * _tmp135 -
                P(13, 15) * _tmp134 - P(14, 15) * _tmp132 + P(5, 15);
  _res(6, 15) = P(3, 15) * dt + P(6, 15);
  _res(7, 15) = P(4, 15) * dt + P(7, 15);
  _res(8, 15) = P(5, 15) * dt + P(8, 15);
  _res(9, 15) = P(9, 15);
  _res(10, 15) = P(10, 15);
  _res(11, 15) = P(11, 15);
  _res(12, 15) = P(12, 15);
  _res(13, 15) = P(13, 15);
  _res(14, 15) = P(14, 15);
  _res(15, 15) = P(15, 15);
  _res(16, 15) = 0;
  _res(17, 15) = 0;
  _res(18, 15) = 0;
  _res(19, 15) = 0;
  _res(20, 15) = 0;
  _res(21, 15) = 0;
  _res(22, 15) = 0;
  _res(0, 16) = P(0, 16) * _tmp18 + P(10, 16) * _tmp23 + P(11, 16) * _tmp6 + P(9, 16) * _tmp15;
  _res(1, 16) = P(1, 16) * _tmp18 + P(10, 16) * _tmp29 + P(11, 16) * _tmp34 + P(9, 16) * _tmp36;
  _res(2, 16) = P(10, 16) * _tmp45 + P(11, 16) * _tmp44 + P(2, 16) * _tmp18 + P(9, 16) * _tmp47;
  _res(3, 16) = P(1, 16) * _tmp75 - P(12, 16) * _tmp57 - P(13, 16) * _tmp61 - P(14, 16) * _tmp64 +
                P(2, 16) * _tmp79 + P(3, 16);
  _res(4, 16) = P(0, 16) * _tmp117 - P(12, 16) * _tmp110 - P(13, 16) * _tmp102 -
                P(14, 16) * _tmp108 + P(2, 16) * _tmp105 + P(4, 16);
  _res(5, 16) = P(0, 16) * _tmp138 + P(1, 16) * _tmp133 - P(12, 16) * _tmp135 -
                P(13, 16) * _tmp134 - P(14, 16) * _tmp132 + P(5, 16);
  _res(6, 16) = P(3, 16) * dt + P(6, 16);
  _res(7, 16) = P(4, 16) * dt + P(7, 16);
  _res(8, 16) = P(5, 16) * dt + P(8, 16);
  _res(9, 16) = P(9, 16);
  _res(10, 16) = P(10, 16);
  _res(11, 16) = P(11, 16);
  _res(12, 16) = P(12, 16);
  _res(13, 16) = P(13, 16);
  _res(14, 16) = P(14, 16);
  _res(15, 16) = P(15, 16);
  _res(16, 16) = P(16, 16);
  _res(17, 16) = 0;
  _res(18, 16) = 0;
  _res(19, 16) = 0;
  _res(20, 16) = 0;
  _res(21, 16) = 0;
  _res(22, 16) = 0;
  _res(0, 17) = P(0, 17) * _tmp18 + P(10, 17) * _tmp23 + P(11, 17) * _tmp6 + P(9, 17) * _tmp15;
  _res(1, 17) = P(1, 17) * _tmp18 + P(10, 17) * _tmp29 + P(11, 17) * _tmp34 + P(9, 17) * _tmp36;
  _res(2, 17) = P(10, 17) * _tmp45 + P(11, 17) * _tmp44 + P(2, 17) * _tmp18 + P(9, 17) * _tmp47;
  _res(3, 17) = P(1, 17) * _tmp75 - P(12, 17) * _tmp57 - P(13, 17) * _tmp61 - P(14, 17) * _tmp64 +
                P(2, 17) * _tmp79 + P(3, 17);
  _res(4, 17) = P(0, 17) * _tmp117 - P(12, 17) * _tmp110 - P(13, 17) * _tmp102 -
                P(14, 17) * _tmp108 + P(2, 17) * _tmp105 + P(4, 17);
  _res(5, 17) = P(0, 17) * _tmp138 + P(1, 17) * _tmp133 - P(12, 17) * _tmp135 -
                P(13, 17) * _tmp134 - P(14, 17) * _tmp132 + P(5, 17);
  _res(6, 17) = P(3, 17) * dt + P(6, 17);
  _res(7, 17) = P(4, 17) * dt + P(7, 17);
  _res(8, 17) = P(5, 17) * dt + P(8, 17);
  _res(9, 17) = P(9, 17);
  _res(10, 17) = P(10, 17);
  _res(11, 17) = P(11, 17);
  _res(12, 17) = P(12, 17);
  _res(13, 17) = P(13, 17);
  _res(14, 17) = P(14, 17);
  _res(15, 17) = P(15, 17);
  _res(16, 17) = P(16, 17);
  _res(17, 17) = P(17, 17);
  _res(18, 17) = 0;
  _res(19, 17) = 0;
  _res(20, 17) = 0;
  _res(21, 17) = 0;
  _res(22, 17) = 0;
  _res(0, 18) = P(0, 18) * _tmp18 + P(10, 18) * _tmp23 + P(11, 18) * _tmp6 + P(9, 18) * _tmp15;
  _res(1, 18) = P(1, 18) * _tmp18 + P(10, 18) * _tmp29 + P(11, 18) * _tmp34 + P(9, 18) * _tmp36;
  _res(2, 18) = P(10, 18) * _tmp45 + P(11, 18) * _tmp44 + P(2, 18) * _tmp18 + P(9, 18) * _tmp47;
  _res(3, 18) = P(1, 18) * _tmp75 - P(12, 18) * _tmp57 - P(13, 18) * _tmp61 - P(14, 18) * _tmp64 +
                P(2, 18) * _tmp79 + P(3, 18);
  _res(4, 18) = P(0, 18) * _tmp117 - P(12, 18) * _tmp110 - P(13, 18) * _tmp102 -
                P(14, 18) * _tmp108 + P(2, 18) * _tmp105 + P(4, 18);
  _res(5, 18) = P(0, 18) * _tmp138 + P(1, 18) * _tmp133 - P(12, 18) * _tmp135 -
                P(13, 18) * _tmp134 - P(14, 18) * _tmp132 + P(5, 18);
  _res(6, 18) = P(3, 18) * dt + P(6, 18);
  _res(7, 18) = P(4, 18) * dt + P(7, 18);
  _res(8, 18) = P(5, 18) * dt + P(8, 18);
  _res(9, 18) = P(9, 18);
  _res(10, 18) = P(10, 18);
  _res(11, 18) = P(11, 18);
  _res(12, 18) = P(12, 18);
  _res(13, 18) = P(13, 18);
  _res(14, 18) = P(14, 18);
  _res(15, 18) = P(15, 18);
  _res(16, 18) = P(16, 18);
  _res(17, 18) = P(17, 18);
  _res(18, 18) = P(18, 18);
  _res(19, 18) = 0;
  _res(20, 18) = 0;
  _res(21, 18) = 0;
  _res(22, 18) = 0;
  _res(0, 19) = P(0, 19) * _tmp18 + P(10, 19) * _tmp23 + P(11, 19) * _tmp6 + P(9, 19) * _tmp15;
  _res(1, 19) = P(1, 19) * _tmp18 + P(10, 19) * _tmp29 + P(11, 19) * _tmp34 + P(9, 19) * _tmp36;
  _res(2, 19) = P(10, 19) * _tmp45 + P(11, 19) * _tmp44 + P(2, 19) * _tmp18 + P(9, 19) * _tmp47;
  _res(3, 19) = P(1, 19) * _tmp75 - P(12, 19) * _tmp57 - P(13, 19) * _tmp61 - P(14, 19) * _tmp64 +
                P(2, 19) * _tmp79 + P(3, 19);
  _res(4, 19) = P(0, 19) * _tmp117 - P(12, 19) * _tmp110 - P(13, 19) * _tmp102 -
                P(14, 19) * _tmp108 + P(2, 19) * _tmp105 + P(4, 19);
  _res(5, 19) = P(0, 19) * _tmp138 + P(1, 19) * _tmp133 - P(12, 19) * _tmp135 -
                P(13, 19) * _tmp134 - P(14, 19) * _tmp132 + P(5, 19);
  _res(6, 19) = P(3, 19) * dt + P(6, 19);
  _res(7, 19) = P(4, 19) * dt + P(7, 19);
  _res(8, 19) = P(5, 19) * dt + P(8, 19);
  _res(9, 19) = P(9, 19);
  _res(10, 19) = P(10, 19);
  _res(11, 19) = P(11, 19);
  _res(12, 19) = P(12, 19);
  _res(13, 19) = P(13, 19);
  _res(14, 19) = P(14, 19);
  _res(15, 19) = P(15, 19);
  _res(16, 19) = P(16, 19);
  _res(17, 19) = P(17, 19);
  _res(18, 19) = P(18, 19);
  _res(19, 19) = P(19, 19);
  _res(20, 19) = 0;
  _res(21, 19) = 0;
  _res(22, 19) = 0;
  _res(0, 20) = P(0, 20) * _tmp18 + P(10, 20) * _tmp23 + P(11, 20) * _tmp6 + P(9, 20) * _tmp15;
  _res(1, 20) = P(1, 20) * _tmp18 + P(10, 20) * _tmp29 + P(11, 20) * _tmp34 + P(9, 20) * _tmp36;
  _res(2, 20) = P(10, 20) * _tmp45 + P(11, 20) * _tmp44 + P(2, 20) * _tmp18 + P(9, 20) * _tmp47;
  _res(3, 20) = P(1, 20) * _tmp75 - P(12, 20) * _tmp57 - P(13, 20) * _tmp61 - P(14, 20) * _tmp64 +
                P(2, 20) * _tmp79 + P(3, 20);
  _res(4, 20) = P(0, 20) * _tmp117 - P(12, 20) * _tmp110 - P(13, 20) * _tmp102 -
                P(14, 20) * _tmp108 + P(2, 20) * _tmp105 + P(4, 20);
  _res(5, 20) = P(0, 20) * _tmp138 + P(1, 20) * _tmp133 - P(12, 20) * _tmp135 -
                P(13, 20) * _tmp134 - P(14, 20) * _tmp132 + P(5, 20);
  _res(6, 20) = P(3, 20) * dt + P(6, 20);
  _res(7, 20) = P(4, 20) * dt + P(7, 20);
  _res(8, 20) = P(5, 20) * dt + P(8, 20);
  _res(9, 20) = P(9, 20);
  _res(10, 20) = P(10, 20);
  _res(11, 20) = P(11, 20);
  _res(12, 20) = P(12, 20);
  _res(13, 20) = P(13, 20);
  _res(14, 20) = P(14, 20);
  _res(15, 20) = P(15, 20);
  _res(16, 20) = P(16, 20);
  _res(17, 20) = P(17, 20);
  _res(18, 20) = P(18, 20);
  _res(19, 20) = P(19, 20);
  _res(20, 20) = P(20, 20);
  _res(21, 20) = 0;
  _res(22, 20) = 0;
  _res(0, 21) = P(0, 21) * _tmp18 + P(10, 21) * _tmp23 + P(11, 21) * _tmp6 + P(9, 21) * _tmp15;
  _res(1, 21) = P(1, 21) * _tmp18 + P(10, 21) * _tmp29 + P(11, 21) * _tmp34 + P(9, 21) * _tmp36;
  _res(2, 21) = P(10, 21) * _tmp45 + P(11, 21) * _tmp44 + P(2, 21) * _tmp18 + P(9, 21) * _tmp47;
  _res(3, 21) = P(1, 21) * _tmp75 - P(12, 21) * _tmp57 - P(13, 21) * _tmp61 - P(14, 21) * _tmp64 +
                P(2, 21) * _tmp79 + P(3, 21);
  _res(4, 21) = P(0, 21) * _tmp117 - P(12, 21) * _tmp110 - P(13, 21) * _tmp102 -
                P(14, 21) * _tmp108 + P(2, 21) * _tmp105 + P(4, 21);
  _res(5, 21) = P(0, 21) * _tmp138 + P(1, 21) * _tmp133 - P(12, 21) * _tmp135 -
                P(13, 21) * _tmp134 - P(14, 21) * _tmp132 + P(5, 21);
  _res(6, 21) = P(3, 21) * dt + P(6, 21);
  _res(7, 21) = P(4, 21) * dt + P(7, 21);
  _res(8, 21) = P(5, 21) * dt + P(8, 21);
  _res(9, 21) = P(9, 21);
  _res(10, 21) = P(10, 21);
  _res(11, 21) = P(11, 21);
  _res(12, 21) = P(12, 21);
  _res(13, 21) = P(13, 21);
  _res(14, 21) = P(14, 21);
  _res(15, 21) = P(15, 21);
  _res(16, 21) = P(16, 21);
  _res(17, 21) = P(17, 21);
  _res(18, 21) = P(18, 21);
  _res(19, 21) = P(19, 21);
  _res(20, 21) = P(20, 21);
  _res(21, 21) = P(21, 21);
  _res(22, 21) = 0;
  _res(0, 22) = P(0, 22) * _tmp18 + P(10, 22) * _tmp23 + P(11, 22) * _tmp6 + P(9, 22) * _tmp15;
  _res(1, 22) = P(1, 22) * _tmp18 + P(10, 22) * _tmp29 + P(11, 22) * _tmp34 + P(9, 22) * _tmp36;
  _res(2, 22) = P(10, 22) * _tmp45 + P(11, 22) * _tmp44 + P(2, 22) * _tmp18 + P(9, 22) * _tmp47;
  _res(3, 22) = P(1, 22) * _tmp75 - P(12, 22) * _tmp57 - P(13, 22) * _tmp61 - P(14, 22) * _tmp64 +
                P(2, 22) * _tmp79 + P(3, 22);
  _res(4, 22) = P(0, 22) * _tmp117 - P(12, 22) * _tmp110 - P(13, 22) * _tmp102 -
                P(14, 22) * _tmp108 + P(2, 22) * _tmp105 + P(4, 22);
  _res(5, 22) = P(0, 22) * _tmp138 + P(1, 22) * _tmp133 - P(12, 22) * _tmp135 -
                P(13, 22) * _tmp134 - P(14, 22) * _tmp132 + P(5, 22);
  _res(6, 22) = P(3, 22) * dt + P(6, 22);
  _res(7, 22) = P(4, 22) * dt + P(7, 22);
  _res(8, 22) = P(5, 22) * dt + P(8, 22);
  _res(9, 22) = P(9, 22);
  _res(10, 22) = P(10, 22);
  _res(11, 22) = P(11, 22);
  _res(12, 22) = P(12, 22);
  _res(13, 22) = P(13, 22);
  _res(14, 22) = P(14, 22);
  _res(15, 22) = P(15, 22);
  _res(16, 22) = P(16, 22);
  _res(17, 22) = P(17, 22);
  _res(18, 22) = P(18, 22);
  _res(19, 22) = P(19, 22);
  _res(20, 22) = P(20, 22);
  _res(21, 22) = P(21, 22);
  _res(22, 22) = P(22, 22);

  return _res;
}  // NOLINT(readability/fn_size)

// NOLINTNEXTLINE(readability/fn_size)
}  // namespace sym
